/* 
 * Principais funções e variáveis utilizadas pela aplicação.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
var urlStartUpList = 'http://service.bigeyessolution.com/cpbr8/startuplist';
var urlRoundStatus = 'http://service.bigeyessolution.com/cpbr8/roundstatus';
var urlDevice = 'http://service.bigeyessolution.com/cpbr8/device.php';
var urlStartup360 = 'http://service.bigeyessolution.com/cpbr8/startup360.php';
var urlBills = 'http://service.bigeyessolution.com/cpbr8/saldo.php';
var urlBaseImages = 'https://s3-sa-east-1.amazonaws.com/app-cpbr8/';
var urlCpSchedule = 'http://api.campuse.ro/api/legacy/events/campus-party-brasil-2015/schedule?format=json';
var urlCpStages = 'http://api.campuse.ro/api/legacy/events/campus-party-brasil-2015/stages?format=json';
var urlDestaques = 'http://service.bigeyessolution.com/cpbr8/destaques.json';

var meses = ['janeiro', 'fevereiro', 'março', 'abril', 'maio', 'junho', 'julho', 'agosto', 'setembro', 'outubro', 'novembro', 'dezembro'];

var presentPage = 'agenda-por-palco.html';
var presentPageOrder = 11;
var defaultPage = 'agenda-por-palco.html';
var defaultPageOrder = '11';
var defaultBtnSelected = '#btn-agenda-por-palco';

var bills =  'Aguarde!';

var gaPlugin = false;

var last_events_verification = (new Date).getTime();
var last_pushn_verification = (new Date).getTime();

function showStage() {
    activities = JSON.parse(window.localStorage.getItem('cp-activities'));

    minha_agenda_id = JSON.parse(window.localStorage.getItem('minha_agenda_id'));
    if (!minha_agenda_id)
        minha_agenda_id = new Array();

    $('.ui-listiview').empty();

    for (i = 0; i < activities.length; i++) {
        activity = activities[i];

        id_li_stage = '';
        switch (activity.stage) {
            case 'Palco Terra':
                id_li_stage = '#ul-palco-terra';
                break;
            case 'Palco Lua':
                id_li_stage = '#ul-palco-lua';
                break;
            case 'Palco Marte':
                id_li_stage = '#ul-palco-marte';
                break;
            case 'Palco Júpiter':
                id_li_stage = '#ul-palco-jupiter';
                break;
            case 'Palco Vênus':
                id_li_stage = '#ul-palco-venus';
                break;
            case 'Palco Saturno':
                id_li_stage = '#ul-palco-saturno';
                break;
            case 'Palco Netuno':
                id_li_stage = '#ul-palco-netuno';
                break;
            case 'Palco Mercúrio':
                id_li_stage = '#ul-palco-mercurio';
                break;
            case 'Palco Urano':
                id_li_stage = '#ul-palco-urano';
                break;
            case 'Palco Sol':
                id_li_stage = '#ul-palco-sol';
                break;
            case 'Palco Workshop 1':
                id_li_stage = '#ul-palco-workshop1';
                break;
            case 'Palco Workshop 2':
                id_li_stage = '#ul-palco-workshop2';
                break;
            case 'Palco Workshop 3':
                id_li_stage = '#ul-palco-workshop3';
                break;
            case 'Palco Cross Space':
                id_li_stage = '#ul-palco-crosspace';
                break;
            case 'Espaços SEBRAE ':
                id_li_stage = '#ul-palco-sebrae';
                break;
            case 'Palco Startup Makers Camp':
                id_li_stage = '#ul-palco-startup';
                break;
            default:

        }

        now = (new Date()).getTime();
        activity_time = (new Date(activity.date)).getTime();

        btnInsc = (activity_time < now) || (minha_agenda_id.indexOf(activity.id) > -1) ? '' :
                '<a id="btn-insc-' + activity.id + '" class="ui-cp-insc-palestra" onclick="inscreverSe ({' +
                "'id':" + activity.id +
                ",'title':'" + activity.title +
                "','date':'" + activity.date +
                "','stage':'" + activity.stage + "'})\"></a>";

        date = new Date(activity.date);
        min = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
        day = (date.getDate() < 10 ? '0' + date.getDate() : date.getDate());
        mon = date.getMonth() + 1;
        mon = (mon < 10 ? '0' + mon : mon);
        $('<li class="ui-cp-listview-content"><div class="ui-grid-a">' +
                '<div class="ui-block-a"><b>' + date.getHours() + ':' + min +
                '</b></br>' + day + '/' + mon + '</div>' +
                '<div class="ui-block-b">' +
                '<span class="ui-cp-palestra">' + activity.title.replace(' ',' <wbr>') + '</span>' +
                '<span class="ui-cp-palestrante">' + activity.speakers.replace(' ',' <wbr>') + '</span>' +
                btnInsc + '</div></div></li>')
                .appendTo(id_li_stage);
    }
    ;

    $('.ui-listiview').listview('refresh');

    cpLoading(false);
}

function showScheduleByDay() {
    schedule = JSON.parse(window.localStorage.getItem('cp-schedule'));

    $('#lista-por-dia .ui-listview').empty();

    minha_agenda_id = JSON.parse(window.localStorage.getItem('minha_agenda_id'));

    if (!minha_agenda_id)
        minha_agenda_id = new Array();

    for (i = 0; i < schedule.length; i++) {
        event = schedule[i];

        date = new Date(event.date);
        min = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
        id_ul_dia = '#dia-' + date.getDate();

        switch (event.stage) {
            case 'Palco Terra':
                bg_name = 'bg_terra.png';
                break;
            case 'Palco Lua':
                bg_name = 'bg_lua.png';
                break;
            case 'Palco Marte':
                bg_name = 'bg_marte.png';
                break;
            case 'Palco Júpiter':
                bg_name = 'bg_jupiter.png';
                break;
            case 'Palco Vênus':
                bg_name = 'bg_venus.png';
                break;
            case 'Palco Saturno':
                bg_name = 'bg_saturno.png';
                break;
            case 'Palco Netuno':
                bg_name = 'bg_netuno.png';
                break;
            case 'Palco Mercúrio':
                bg_name = 'bg_mercurio.png';
                break;
            case 'Palco Urano':
                bg_name = 'bg_urano.png';
                break;
            case 'Palco Sol':
                bg_name = 'bg_sol.png';
                break;
            case 'Palco Workshop 1':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Workshop 2':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Workshop 3':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Cross Space':
                bg_name = 'bg_terra2.png';
                break;
            case 'Espaços SEBRAE ':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Startup Makers Camp':
                bg_name = 'bg_terra2.png';
                break;
            default:
                bg_name = 'bg_terra2.png';
        }

        now = (new Date()).getTime();
        event_time = (new Date(event.date)).getTime();

        btnInsc = (event_time < now) || (minha_agenda_id.indexOf(event.id) > -1) ? '' :
                '<a id="btn-insc-' + event.id + '" class="ui-cp-insc-palestra" onclick="inscreverSe ({' +
                "'id':" + event.id +
                ",'title':'" + event.title +
                "','date':'" + event.date +
                "','stage':'" + event.stage + "'})\"></a>";

        $('<li class="ui-cp-listview-content"><div class="ui-grid-a">' +
                '<div class="ui-block-a ui-cp-por-dia-palco">' +
                '<img src="img/' + bg_name + '">'+
                '<p>' + event.stage.replace(' ',' <wbr>') + '</p>' +
                '<b>' + date.getHours() + ':' + min + '</b></div>' +
                '<div class="ui-block-b">' +
                '<span class="ui-cp-palestra">' + event.title.replace(' ',' <wbr>') + '</span>' +
                '<span class="ui-cp-palestrante">' + event.speakers.replace(' ',' <wbr>') + '</span></br>' +
                btnInsc +
                '</div></div></li>')
                .appendTo(id_ul_dia);
    }
    ;

    $('.ui-listiview').listview('refresh');

    cpLoading(false);
}

function showMinhaAgenda() {
    $('#ul-minha-agenda').empty();
    $('#ul-minha-agenda').listview('refresh');

    now = (new Date()).getTime();
    event_time_ant = now;

    minha_agenda = JSON.parse(window.localStorage.getItem('minha_agenda'));
    
    if (!minha_agenda) {
        //TODO: Mostra algum feedback na tela vazia
        return;
    }
    
    id_selected_now = false;
    id_selected_ant = '#li-agenda-' + minha_agenda[0].id;
    
    for (i = 0; i < minha_agenda.length; i++) {
        event = minha_agenda[i];

        date = new Date(event.date);
        event_time = date.getTime();
        
        if (now > event_time) continue;
        
        id_ul_dia = '#dia-' + date.getDate();
        
        switch (event.stage) {
            case 'Palco Terra':
                bg_name = 'bg_terra.png';
                break;
            case 'Palco Lua':
                bg_name = 'bg_lua.png';
                break;
            case 'Palco Marte':
                bg_name = 'bg_marte.png';
                break;
            case 'Palco Júpiter':
                bg_name = 'bg_jupiter.png';
                break;
            case 'Palco Vênus':
                bg_name = 'bg_venus.png';
                break;
            case 'Palco Saturno':
                bg_name = 'bg_saturno.png';
                break;
            case 'Palco Netuno':
                bg_name = 'bg_netuno.png';
                break;
            case 'Palco Mercúrio':
                bg_name = 'bg_mercurio.png';
                break;
            case 'Palco Urano':
                bg_name = 'bg_urano.png';
                break;
            case 'Palco Sol':
                bg_name = 'bg_sol.png';
                break;
            case 'Palco Workshop 1':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Workshop 2':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Workshop 3':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Cross Space':
                bg_name = 'bg_terra2.png';
                break;
            case 'Espaços SEBRAE ':
                bg_name = 'bg_terra2.png';
                break;
            case 'Palco Startup Makers Camp':
                bg_name = 'bg_terra2.png';
                break;
            default:
                bg_name = 'bg_terra2.png';
        }

        min = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
        day = (date.getDate() < 10 ? '0' + date.getDate() : date.getDate());
        mon = date.getMonth() + 1;
        mon = (mon < 10 ? '0' + mon : mon);


        if (id_selected_now == false && (now >= event_time_ant || now < event_time))
        {
            id_selected_now = id_selected_ant;
        } else {
            id_selected_ant = '#li-agenda-' + event.id;
        }

        btnDesinsc = event_time < now ? '' :
                '<a id="btn-remove-insc-' + event.id + '" class="ui-cp-cancel" onclick="desinscreverSe (' + event.id + ')"></a>';

        $('<li id="li-agenda-' + event.id + '" class="ui-cp-listview-content"><div class="ui-grid-a">' +
                '<div class="ui-block-a ui-cp-por-dia-palco">' +
                '<img src="img/' + bg_name + '"><br><p>' + event.stage.replace(' ',' <wbr>') + '</p></div>' +
                '<div class="ui-block-b">' +
                '<span class="ui-cp-palestra">' + event.title.replace(' ',' <wbr>') + '</span>' +
                '<b>' + day + '/' + mon + ' ' + date.getHours() + ':' + min + '</b>' +
                btnDesinsc +
                '</div></div></li>')
                .appendTo("#ul-minha-agenda");
    }
    ;

    $('#ul-minha-agenda').listview('refresh');
}

function showDestaques () {
    $("#destaques-list").empty();
    
    $.getJSON(urlDestaques, function(data) 
    {
        window.localStorage.setItem('destaques', JSON.stringify(data.containers));
    });
    
    destaques_list = window.localStorage.getItem('destaques');
    
    destaques_list = destaques_list ? JSON.parse(destaques_list) : [];
    
    $.each(destaques_list, function(key,container)
    {
        $( '<div data-role="collapsible" data-inset="false" class="ui-cp-destaques animateMe">'+
             '<h1 class="ui-cp-collapsible-title ui-collapsible-heading">'+
             '<span style="display: block; background:url(\'' + container.main_image_url + '\') no-repeat center center; width: 100%; height: 175px !important;">' +
             '<h4 style="color: #000000; background-color: rgba(255,255,255,0.8); padding: 20px; float:left; margin-top:70px;">' + 
             container.title.replace(' ', ' <wbr>') + 
             '</h4></span></h1>' + 
             '<div style="padding: 1rem">' + container.content + '</div></div>'
             ).appendTo('#destaques-list');
     });
    
    $('#destaques-list').trigger('create');
    
    imagesLoaded(document.querySelector('#destaques-list'), function (instance) {
        cpLoading(false);
    });
}

function prepareCpSchedule(cp_schedule) {
    window.localStorage.setItem('cp-schedule-time', (new Date()).getTime());
    window.localStorage.setItem('cp-schedule', JSON.stringify(cp_schedule));
}

/**
 * 
 * @param {type} cp_stages
 * @returns {undefined}
 */
function prepareCpActivities(cp_stages) {
    allactivities = [];

    for (i = 0; i < cp_stages.length; i++) {
        allactivities = allactivities.concat(cp_stages[i].activities);
    }

    allactivities.sort(function (a, b) {
        date_a = (new Date(a.date)).getTime();
        date_b = (new Date(b.date)).getTime();
        return date_a - date_b;
    });

    window.localStorage.setItem('cp-activities-time', (new Date()).getTime());
    window.localStorage.setItem('cp-activities', JSON.stringify(allactivities));
}

/**
 * //@TODO: Verificar se o evento já acabou, se sim selecionar a página.
 *
 * Seleciona qual a primeira página a ser exibida. Até o termino do evento esta
 * página será a agenda-por-palco.html, depois a página será destaques.html.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function choiceFirstPage() {
    presentPage = 'agenda-por-palco.html';
    presentPageOrder = 11;
    defaultPage = 'agenda-por-palco.html';
    defaultPageOrder = '11';
    defaultBtnSelected = '#btn-agenda-por-palco';
} // END: function choiceFirstPage()

/**
 * Alterna entre exibir/ocultar os menu principal do app.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function toggleMenuNavBar() {
    if ($('.cp-ui-navbar').hasClass('cp-ui-small-toolbar')) {
        $('.cp-ui-btn-navbar').fadeIn('slow');
        $('.cp-ui-navbar').animate({height: '4.938rem'}, 'slow');
        $('.cp-ui-navbar').removeClass('cp-ui-small-toolbar').addClass('cp-ui-normal-toolbar');
        cpLoading(false);
    } else {
        $('.cp-ui-navbar').animate({height: '0.5rem'}, 'slow');
        $('.cp-ui-btn-navbar').fadeOut('slow');
        $('.cp-ui-navbar').removeClass('cp-ui-normal-toolbar').addClass('cp-ui-small-toolbar');
    }
} // END: function toggleMenuNavBar()

/**
 * //@TODO: Inserir a um parametro para tratamento (handler) se necessário.
 *
 * Alterna entre diferentes páginas escolhendo a animação a ser aplicada.
 *
 * @param pageRef String url da página que será exibida.
 * @param relativeOrder Number ordem da página utilizada para determinar se animaçção será reverse.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function appChangePage(pageRef, relativeOrder, callBackAfter) {
    /* Escolhendo o tipo de animação e, caso seja slide, se será voltando ou não.*/
    animationTo = (presentPageOrder === relativeOrder) ? "fade" : "slide";
    reverseOp = presentPageOrder > relativeOrder;
            
    presentPage = pageRef;
    presentPageOrder = relativeOrder;
    
    if (gaPlugin !== false) {
        gaPlugin.trackPage (gpSuccessHandler, gpErrorHandler,  pageRef);
    }
    
    $.mobile.changePage(pageRef, {transition: animationTo, reverse: reverseOp, changeHash: false});
    
    if (callBackAfter) {
        callBackAfter();
    }
} // END: function appChangePage(pageRef, relativeOrder)

/**
 * Marca o botão btn como selecionado da toolbar em agendas.
 *
 * @param btn String com o seletor (id) do botão a ser selecionado.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function setBtnSelected(btn) {
    $('.cp-ui-footer-btn-selected').removeClass('cp-ui-footer-btn-selected');
    $(btn).addClass('cp-ui-footer-btn-selected');
} // END: function setBtnSelected(btn)

/**
 * Verifica o versão da lista de startups e o round atual do Startup360.
 * Se desatualizado chama a função startupsGetList,
 * do contrário chama showStartupsList
 *
 * @see showStartupsList
 * @see startupsGetList
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function startupsListVersionVerify() {
    $.getJSON(urlRoundStatus, function (data) {
        startupListVersion = data[0].version;
        startup360Round = parseInt(data[0].round);

        localround = parseInt(window.localStorage.getItem('startup360Round'));
        
        if (startup360Round != localround) {
            window.localStorage.setItem('startup360Round', startup360Round);
        }

        if (startup360Round == 0) {
            window.localStorage.setItem('startup360Bills', 10000);
        }else{
            updateBills();
        }

        startup360ListBtn();
        
        if (window.localStorage.getItem('startupsListVersion') == data[0].version) {
            startups = window.localStorage.getItem('startupsList');
            showStartupsList(data[0].round, JSON.parse(startups));
        } else {
            startupsGetList(data[0].version);
        }
    }).fail(function () {
        startup360ListBtn();

        startups = window.localStorage.getItem('startupsList');

        if (startups) {
            startups = JSON.parse(startups);
            showStartupsList(window.localStorage.getItem('startup360Round'), startups);
        }
    });
} // END: function startupsListVersionVerify()

function updateBills () {
    $.getJSON(urlBills,{uuid:device.uuid},function (data) 
    {
        round = parseInt(window.localStorage.getItem('startup360Round'));
        bills = round == 1 ? data.round1 : data.round2;
        window.localStorage.setItem('startup360Bills', bills);
    });
}

/**
 * Exibe ou oculta o botão de QR-Code da lista de startups conforme o round ou
 * os créditos restantes do device.
 * 
 * @todo: testar o round e os créditos.
 * 
 * @returns {undefined}
 */
function startup360ListBtn() {    
    round = parseInt(window.localStorage.getItem('startup360Round'));
    
    bills = round == 0 ? 10000 : parseInt(window.localStorage.getItem('startup360Bills'));
    
    $('#btn-bills').html('<a>cp$ ' + bills + ',00</a>');

    if (round == 0 || parseInt(bills) == 0) {
        $('#btn-qrcode').html('<a>&nbsp;</a>');
        $('#btn-qrcode').removeClass('ui-cp-btn-qrcode-enabled')
                .addClass('ui-cp-btn-qrcode-disabled');
    } else {
        $('#btn-qrcode').html('<a onclick="investir()">QR-Code</a>');
        $('#btn-qrcode').removeClass('ui-cp-btn-qrcode-disables')
                .addClass('ui-cp-btn-qrcode-enabled');
    }
}

/**
 * Obtem uma nova lista de startups e a exibe.
 *
 * @see startupsListVersionVerify
 * @see showStartupsList
 *
 * @param version Number Número de versão da lista a ser obtida.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function startupsGetList(version) {
    $.getJSON(urlStartUpList, function (data) {
        list = data._embedded.startuplist;
        window.localStorage.setItem('startupsList', JSON.stringify(list));
        window.localStorage.setItem('startupsListVersion', version);
        showStartupsList(window.localStorage.getItem('startup360Round'), list);
    });
} // END: function startupsListVersionVerify()

/**
 * Exibe a lista das startups participantes na página Startups360 de acordo
 * com o round atual ou todos caso 0.
 *
 * @param round Number Número do atual round na Startup360, 0 se nenhum.
 * @param startups Array Lista das startups participantes.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function showStartupsList(round, startups) {
    itens = [];

    $('#startup360 ul').empty();

    $('#startup360 ul').listview('refresh');

    $.each(startups, function (index, startup) {
        if (round == startup.round || round == 0) {
            $('<li class="ui-li-static ui-body-inherit ui-li-has-thumb" style="background-color: #fff !important; border-bottom: #ccc 1px solid !important; color: #333 !important; text-shadow: 0 1px 0 #f3f3f3 !important; text-overflow: ellipsis !important; " onclick="showDescription(' + startup.id + ')">' +
            '<img src="' + urlBaseImages + 'thumb_' + startup.id + '.jpg">' +
            '<h3>' + startup.name + '</h3>' +
            '<p style="text-overflow: ellipsis; ">' + startup.description + '</p></li>'
            ).appendTo('#startup360 ul');

        }
    });
    
    $('#startup360 ul').listview('refresh');

    imagesLoaded(document.querySelector('#startups-list'), function (instance) {
        cpLoading(false);
    });
} // END: function showStartupsList(round, startups)

/**
 * Exibe a página detalhes.html de startup passando para a mesma o startup_id 
 * para que sejam obtidos os conteúdos. 
 * 
 * @param {type} startup_id ID da startup a ser exibida.
 * @returns {undefined}
 */
function showDescription(startup_id) {
    if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
        toggleMenuNavBar();
    }
    
    __show_startup_id = startup_id;
    $.each(JSON.parse(window.localStorage.getItem('startupsList')),
    function (key, startup) {
        if (startup.id == __show_startup_id)
        {
            __show_startup = startup;
            return false;
        }
    });

    appChangePage('detalhes.html', 31, false);
}
var __show_startup_id = 0;
var __show_startup = false;

/**
 * Exibe ou oculta o sinal de carregamento.
 * 
 * @author Laudivan F Almeida <laudivan@bigeyessolution.com>
 * 
 * @param bool show Exibe se true e oculta se false
 */
function cpLoading(show) {
    if (show) {
        $('#cp-navbar-top').addClass('cp-ui-loading');
    } else {
        $('#cp-navbar-top').removeClass('cp-ui-loading');
    }
}

/**
 * Retorna para página de Startups.
 * @note: Esta função foi criada para ser utilizada dentro de um <a>
 * @returns {undefined}
 */
function detailToStartup360() {
    appChangePage('startup360.html', 30, function () {
        cpLoading('true');
        startupsListVersionVerify();
    });
}

/**
 * @TODO: adequar o processo para web app.
 * @returns {undefined}
 */
function deviceVerify() {
    if (window.localStorage.getItem('StartUp360Key') == null) {
        $.post(urlDevice, {"uuid":device.uuid,"model":device.model,"platform":device.platform}, 
        function (data)
        {
            if(typeof data.key != 'undefined') {
                window.localStorage.setItem('StartUp360Key', data.key);
            }
        });
    }
}

/**
 * 
 * @param {type} activity
 * @returns {undefined}
 */
function inscreverSe(activity) {
//    minha_agenda = JSON.parse(window.localStorage.getItem('minha_agenda'));
//    minha_agenda_id = JSON.parse(window.localStorage.getItem('minha_agenda_id'));

    if (!minha_agenda)
    {
        minha_agenda = new Array();
        minha_agenda_id = new Array();
    }

    if (minha_agenda_id.indexOf(activity.id) < 0)
    {
        minha_agenda.push({'id': activity.id, 'title': activity.title, 'date': activity.date, 'stage': activity.stage});
        minha_agenda_id.push(activity.id);

        minha_agenda.sort(function (a, b) {
            date_a = (new Date(a.date)).getTime();
            date_b = (new Date(b.date)).getTime();
            return date_a - date_b;
        });

        window.localStorage.setItem("minha_agenda", JSON.stringify(minha_agenda));
        window.localStorage.setItem("minha_agenda_id", JSON.stringify(minha_agenda_id));
    }

    $('#btn-insc-' + activity.id).fadeOut();
}

/**
 * 
 * @param {type} event_id
 * @returns {undefined}
 */
function desinscreverSe(event_id) {
//    minha_agenda = JSON.parse(window.localStorage.getItem('minha_agenda'));
//    minha_agenda_id = JSON.parse(window.localStorage.getItem('minha_agenda_id'));

    for (i = 0; i < minha_agenda.length; i++) {
        id = minha_agenda[i].id;

        if (event_id == id) {
            minha_agenda.splice(i, 1);
            minha_agenda_id.splice(minha_agenda_id.indexOf(id), 1);
            
            if(minha_agenda.length == 0) {
                window.localStorage.removeItem('minha_agenda');
                window.localStorage.removeItem('minha_agenda_id');
            } else {
                window.localStorage.setItem('minha_agenda', JSON.stringify(minha_agenda));
                window.localStorage.setItem('minha_agenda_id', JSON.stringify(minha_agenda_id));
            }

            $('#li-agenda-' + id).fadeOut();
            $('#ul-minha-agenda').remove('#li-agenda-' + id);
            return;
        }
    }

}

/**
 * 
 * @returns {undefined}
 */
function investir() {
    if(gaPlugin !== false) {
        gaPlugin.setVariable( gpSuccessHandler, gpErrorHandler, 1, "Investir em startup");
        gaPlugin.trackEvent(gpSuccessHandler, gpErrorHandler, 'Button', 'Click', 'Ler QR-Code', 1);
    }
    cordova.plugins.barcodeScanner.scan(
        function (result) {
            url = result.text;

            __startup_id = url.split('?id=')[1];
            startup = getStartupById(__startup_id);

            navigator.notification.confirm(
            'Deseja investir cp$ 1.000,00 na startup '+startup.name+'?',
            function(buttonIndex) {
                if( buttonIndex == 1 ) {
                    if(gaPlugin !== false) {
                        gaPlugin.setVariable( gpSuccessHandler, gpErrorHandler, 1, "Confirmar investimento");
                        gaPlugin.trackEvent(gpSuccessHandler, gpErrorHandler, 'Button', 'Click', 'Confirmar', 1);
                    }
                    
                    device_id = device.uuid;

                    $.post(urlStartup360,
                    {"startup_id": __startup_id, "device_id": device_id},
                    function(data)
                    {
                        if(data.message) {
                            navigator.notification.alert(data.message, 
                            function(){},
                            'Startup360');

                            if (data.success) {
                                updateBills();
                            }
                        }else{
                            navigator.notification.alert('Ocorreu um erro ao acessar a rede.', 
                            function(){}, 'Erro de rede');
                        }
                    });
                }
            },
            'Startup 360',
            ['Sim', 'Não']
            );
        },
        function (error) {
            alert('Não foi possível reconhecer o QR-Code');
        }
    );
}
var __startup_id = '';

/**
 * Obtem as informações da startup a partir do localStorage
 * 
 * @author Laudivan F Almeida <laudivan@bigeyessolution.com>
 * @param {type} startup_id
 * @returns {Array|Object|startups|Boolean}
 */
function getStartupById (startup_id) {
    startups = JSON.parse(window.localStorage.getItem('startupsList'));
    
    for(i=0; i<startups.length; i++) {
        if (startups[i].id == startup_id) {
            return startups[i];
        }
    }
    
    return false;
}

/**
 * Retorna os eventos marcados para os próximos 10 minutos.
 * 
 * @returns {undefined}
 */
function getMyNext10MinEvents () {
    next_events = [];
    
    now = (new Date()).getTime();
    
    for (i=0; i < minha_agenda.length; i++) {
        event_date_time = new Date(minha_agenda[i].date);
        event_time = (event_date_time).getTime();
        
        if (now < event_time && event_time <= now + 600000) {
            next_events.push(minha_agenda[i].title);
        } else {
            //Pode retornar daqui, pois os eventos estão
            //em ordem crescente de date
            return next_events;
        }
    }
    
    return next_events;
}

/**
 * 
 * @returns {undefined}
 */
function updateCacheMinhaAgenda () {
    minha_agenda_id = [];
    minha_agenda = [];
    
    _minha_agenda = window.localStorage.getItem('minha_agenda');
    
    if (_minha_agenda) {
        _minha_agenda = JSON.parse(_minha_agenda);
    } else {        
        return;
    }
    
    now = (new Date()).getTime();
    for (i=0; i < _minha_agenda.length; i++) {
        event_time = (new Date(_minha_agenda_id.date)).getTime();
        
        if (now > event_time) continue;
        
        minha_agenda.push(_minha_agenda[i]);
        minha_agenda_id.push(_minha_agenda[i].id);
    }
    
    window.localStorage.setItem('minha_agenda', minha_agenda);
    window.localStorage.setItem('minha_agenda_id', minha_agenda_id);
}

var minha_agenda = [];
var minha_agenda_id = [];

/**
 * Inicializa as variáveis e prepara a aplicação para ser utilizada.
 *
 * @author Laudivan Freire de Almeida <laudivan@bigeyessolution.com>
 */
function initApp() {
    cpLoading(true);
    
    $("[data-role='navbar']").navbar();
    $("#cp-main-header,#cp-footer-agenda").toolbar();

    $('#btn-menu').click(function () {
        toggleMenuNavBar();
    });
    
    $('#btn-map').click(function () {
        if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
            $('.cp-ui-navbar').height('0.5rem');
            $('.cp-ui-btn-navbar').hide();
            $('.cp-ui-navbar').removeClass('cp-ui-normal-toolbar').addClass('cp-ui-small-toolbar');        
        }
        
        $('#cp-footer-agenda').toolbar('hide');
        
        appChangePage('mapa.html', 100, function () { });
    });

    $('#btn-agenda').click(function () {
        toggleMenuNavBar();

        appChangePage(defaultPage, defaultPageOrder, function () {
            cpLoading(true);
            $('#cp-footer-agenda').toolbar('show');
            setBtnSelected(defaultBtnSelected);
        });
    });

    $('#btn-agenda-por-palco').click(function () {
        if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
            toggleMenuNavBar();
        }
        
        appChangePage('agenda-por-palco.html', 11, function () {
            cpLoading(true);
            setBtnSelected('#btn-agenda-por-palco');
        });
    });

    $('#btn-agenda-por-dia').click(function () {
        if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
            toggleMenuNavBar();
        }
        
        appChangePage('agenda-por-dia.html', 12, function () {
            cpLoading(true);
            setBtnSelected('#btn-agenda-por-dia');
        });
    });

    $('#btn-minha-agenda').click(function () {
        if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
            toggleMenuNavBar();
        }
        
        appChangePage('minha-agenda.html', 13, function () {
            cpLoading(true);
            setBtnSelected('#btn-minha-agenda');
        });
    });

    $('#btn-destaques').click(function () {
        toggleMenuNavBar();

        appChangePage('destaques.html', 20, function () {
            cpLoading(true);
            $('#cp-footer-agenda').toolbar('hide');
        });
    });

    $('#btn-startup360').click(function () {
        toggleMenuNavBar();
        cpLoading('true');
        deviceVerify();
        updateBills();

        appChangePage('startup360.html', 30, function () {
            $('#cp-footer-agenda').toolbar('hide');
        });

    });

    $('#btn-sobre').click(function () {
        toggleMenuNavBar();

        appChangePage('sobre.html', 40, function () {
            $('#cp-footer-agenda').toolbar('hide');
        });
    });

    // Anima os blocos collpalible que pertençam à classe .animateMe
    $(document).on("pagecontainerchange", function (event, ui) {
        $(".animateMe .ui-collapsible-heading-toggle").on("click", function (e) {
            var current = $(this).closest(".ui-collapsible");

            if (current.hasClass("ui-collapsible-collapsed")) {
                //collapse all others and then expand this one
                $(".ui-collapsible").not(".ui-collapsible-collapsed").find(
                        ".ui-collapsible-heading-toggle"
                        ).click();
                $(".ui-collapsible-content", current).slideDown(300);
            } else {
                $(".ui-collapsible-content", current).slideUp(300);
            }
        });
        
        switch($(ui.toPage).attr('id')) {
            case 'minha-agenda':
                showMinhaAgenda();
                cpLoading(false);
                break;
            case 'agenda-por-palco':
                last_update_time = parseInt(window.localStorage.getItem('cp-activities-time'));
                time = (new Date()).getTime() - last_update_time;

                if (time < 1800000 ) // 30 minutos
                {
                    showStage();
                } else
                {
                    $.getJSON(urlCpStages, function (cp_stages) {
                        prepareCpActivities(cp_stages);
                        showStage();
                    }).fail(function () {
                        showStage();
                    });
                }
                break;
            case 'agenda-por-dia':
                last_update_time = parseInt(window.localStorage.getItem('cp-schedule-time'));
                time = (new Date()).getTime() - last_update_time;

                if (time < 1800000 ) // 30 minutos
                {
                    showScheduleByDay();
                } else
                {
                    $.getJSON(urlCpSchedule, function (cp_schedule) {
                        prepareCpSchedule(cp_schedule);
                        showScheduleByDay();
                    }).fail(function () {
                        showScheduleByDay();
                    });
                }
                break;
            case 'destaques':
                showDestaques();
                break;
            case 'startup360':
                startupsListVersionVerify();
                
                startup360ListBtn();
                break;
            case 'mapa':
                break;
        }
    });

    choiceFirstPage();
    setBtnSelected(defaultBtnSelected);
    
     if (window.localStorage.getItem('ja-viu-notificacao') !== '1') {
        navigator.notification.confirm (
            'Aproveite para investir na sua startup favorita, visite o espaço do Startup & Makers e através do QR code presente em cada stand você apóia os melhores projetos!',
            function (buttonIndex)
            {
                if (buttonIndex == 2) { //Investir
                    cpLoading('true');
                    deviceVerify();
                    updateBills();

                    appChangePage('startup360.html', 30, function () {
                        $('#cp-footer-agenda').toolbar('hide');
                    });
                }
                
                window.localStorage.setItem('ja-viu-notificacao', 1);
            },
            'Startup & Makers',
            ['Ver agenda','Investir']
        );
    }
    
    $.mobile.changePage(defaultPage, {
        transition: 'fade',
        changeHash: false
    });
    
    document.addEventListener("backbutton", function()
    {
        if($('.cp-ui-navbar').hasClass('cp-ui-normal-toolbar')) {
            toggleMenuNavBar();
        }
        
        if (presentPage === defaultPage) return;

        appChangePage(defaultPage, defaultPageOrder, function () {
            cpLoading(true);
            $('#cp-footer-agenda').toolbar('show');
            setBtnSelected(defaultBtnSelected);
        });
    }, false);
    
    document.addEventListener("pause", function () {
        gaPlugin.exit(gpSuccessHandler, gpErrorHandler);
        gaPlugin = false;
    }, false);
    
    document.addEventListener("resume", function () {
        if(gaPlugin === false) {
            initGapPlugin();
        }
    }, false);
    
    initGapPlugin();
    
    updateCacheMinhaAgenda (); //Carrega a agenda em storeCache.
} // END: function initApp()

function initGapPlugin () {
    if (gaPlugin === false) {
        gaPlugin = window.plugins.gaPlugin;
        gaPlugin.init(gpSuccessHandler, gpErrorHandler, "UA-59229933-1", 10);
    }
}

function gpSuccessHandler() {
    
}

function gpErrorHandler(){
    
}